"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_linker_sdk_1 = require("ts-linker-sdk");
var meta_1 = require("./meta");
var meta = meta_1.getMetaData();
var PING_INTERVAL = 50 * 1000;
var WebSocketClient = (function () {
    function WebSocketClient(wsUrl, token, sid, chatToken) {
        this.status = {
            created: false,
            connected: false,
            login: false
        };
        this.wsUrl = wsUrl;
        this.token = token;
        this.chatToken = chatToken;
        this.sid = sid;
    }
    WebSocketClient.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.create()];
            });
        });
    };
    WebSocketClient.prototype.getStatus = function () {
        return this.status;
    };
    WebSocketClient.prototype.create = function () {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            var _this = this;
            return __generator(this, function (_a) {
                url = this.wsUrl;
                return [2, new Promise(function (resolve, reject) {
                        if (!url) {
                            throw new Error('websocket url is required.');
                        }
                        _this.client = ts_linker_sdk_1.Client.getInstance(url, {
                            onOpen: function () { return __awaiter(_this, void 0, void 0, function () {
                                var data;
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            try {
                                                this.ping();
                                                this.interval = setInterval(function () {
                                                    _this.ping();
                                                }, PING_INTERVAL);
                                            }
                                            catch (err) {
                                                console.error(err);
                                                reject(err);
                                            }
                                            return [4, this.connect()];
                                        case 1:
                                            data = _a.sent();
                                            return [4, this.authentication()];
                                        case 2:
                                            _a.sent();
                                            resolve(data.value);
                                            return [2];
                                    }
                                });
                            }); },
                            onError: function () {
                                resolve(false);
                            },
                            onClose: function () {
                                clearInterval(_this.interval);
                            }
                        });
                    })];
            });
        });
    };
    WebSocketClient.prototype.on = function (url, callback) {
        if (!url) {
            throw new Error('url is required.');
        }
        this.client.addMessageListener(url, callback);
    };
    WebSocketClient.prototype.off = function (url) {
        this.client.removeMessageListener(url);
    };
    WebSocketClient.prototype.request = function (url, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.client.request(url, data)];
            });
        });
    };
    WebSocketClient.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var sid, data, id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sid = this.sid;
                        if (sid) {
                            this.client.setRequestProperty('sid', sid);
                        }
                        return [4, this.request('/v1/session/start', __assign({}, this.chatToken, meta))];
                    case 1:
                        data = _a.sent();
                        if (data && data.value) {
                            id = data.value;
                            this.sid = id;
                            this.client.setRequestProperty('sid', id);
                        }
                        return [2, data || true];
                }
            });
        });
    };
    WebSocketClient.prototype.ping = function () {
        return this.client.ping({});
    };
    WebSocketClient.prototype.authentication = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tk, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tk = this.token;
                        return [4, this.request('/v1/session/bind/uid/by/token', { token: tk })];
                    case 1:
                        data = _a.sent();
                        return [2, data || true];
                }
            });
        });
    };
    WebSocketClient.prototype.onMessage = function (callback) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.on('/v1/message/listener', callback);
                return [2];
            });
        });
    };
    WebSocketClient.prototype.sendMessage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/send/message', data)];
            });
        });
    };
    WebSocketClient.prototype.markServiced = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/mark/message/serviced', data)];
            });
        });
    };
    WebSocketClient.prototype.getHistoryMessage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/history/message', data)];
            });
        });
    };
    WebSocketClient.prototype.updateStatus = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/session/status', data)];
            });
        });
    };
    WebSocketClient.prototype.getSessionLists = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/session/lists', {})];
            });
        });
    };
    WebSocketClient.prototype.getAllConversations = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/get/all/conversation', data)];
            });
        });
    };
    WebSocketClient.prototype.getAllContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/get/all/contact', data)];
            });
        });
    };
    WebSocketClient.prototype.addContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact', data)];
            });
        });
    };
    WebSocketClient.prototype.deleteContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/delete/contact', data)];
            });
        });
    };
    WebSocketClient.prototype.maskingContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/masking', data)];
            });
        });
    };
    WebSocketClient.prototype.removeMaskingContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/contact/masking', data)];
            });
        });
    };
    WebSocketClient.prototype.stickingContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/stick', data)];
            });
        });
    };
    WebSocketClient.prototype.removeStickContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/contact/stick', data)];
            });
        });
    };
    WebSocketClient.prototype.setNoDisturbing = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/no/disturbing', data)];
            });
        });
    };
    WebSocketClient.prototype.removeNoDisturbing = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/contact/no/disturbing', data)];
            });
        });
    };
    WebSocketClient.prototype.agreeAddContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/agree', data)];
            });
        });
    };
    WebSocketClient.prototype.rejectAddContact = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/reject', data)];
            });
        });
    };
    WebSocketClient.prototype.addContactServiced = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/contact/serviced', data)];
            });
        });
    };
    WebSocketClient.prototype.createChatroom = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/create/chatroom', data)];
            });
        });
    };
    WebSocketClient.prototype.destroyChatroom = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/destroy/chatroom', data)];
            });
        });
    };
    WebSocketClient.prototype.leaveChatroom = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/leave/chatroom', data)];
            });
        });
    };
    WebSocketClient.prototype.getChatroomProfile = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/get/chatroom/profile', data)];
            });
        });
    };
    WebSocketClient.prototype.updateChatroomSubject = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/update/chatroom/subject', data)];
            });
        });
    };
    WebSocketClient.prototype.updateChatroomDescription = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/update/chatroom/description', data)];
            });
        });
    };
    WebSocketClient.prototype.addChatroomAdmin = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/chatroom/admin', data)];
            });
        });
    };
    WebSocketClient.prototype.removeChatroomAdmin = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/chatroom/admin', data)];
            });
        });
    };
    WebSocketClient.prototype.addChatroomAdmins = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/add/chatroom/admins', data)];
            });
        });
    };
    WebSocketClient.prototype.removeChatroomAdmins = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/chatroom/admins', data)];
            });
        });
    };
    WebSocketClient.prototype.joinChatroom = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/join/chatroom', data)];
            });
        });
    };
    WebSocketClient.prototype.removeChatroomMember = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/remove/chatroom/member', data)];
            });
        });
    };
    WebSocketClient.prototype.fetchStickChatroom = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/fetch/stick/chatroom', data)];
            });
        });
    };
    WebSocketClient.prototype.fetchChatroomMembers = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/fetch/chatroom/members', data)];
            });
        });
    };
    WebSocketClient.prototype.searchHistoryMessage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.request('/v1/search/history/message', data)];
            });
        });
    };
    return WebSocketClient;
}());
exports.WebSocketClient = WebSocketClient;
