"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var WebSocketClient_1 = require("./../WebSocketClient");
var CmdMsg_1 = require("../protocol/CmdMsg");
var WsApi = (function (_super) {
    __extends(WsApi, _super);
    function WsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WsApi.prototype.sendMsg = function (msg) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sendMessage(msg)];
            });
        });
    };
    WsApi.prototype.sendGetCmdMsg = function (action, extra) {
        if (extra === void 0) { extra = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var msg;
            return __generator(this, function (_a) {
                msg = CmdMsg_1.CmdMsg.createMsg(__assign({ from: this.from, action: action }, extra));
                return [2, this.sendMsg(msg)];
            });
        });
    };
    WsApi.prototype.sendPostCmdMsg = function (action, userIds, extra) {
        if (extra === void 0) { extra = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var msg;
            return __generator(this, function (_a) {
                msg = CmdMsg_1.CmdMsg.createMsg(__assign({ from: this.from, to: (userIds || []).join(','), action: action }, extra));
                return [2, this.sendMsg(msg)];
            });
        });
    };
    WsApi.prototype.getRoster = function () {
        return this.sendGetCmdMsg('getRoster');
    };
    WsApi.prototype.addFriends = function (userIds) {
        return this.sendPostCmdMsg('addFriends', userIds);
    };
    WsApi.prototype.agreeFriends = function (userIds) {
        return this.sendPostCmdMsg('agreeFriends', userIds);
    };
    WsApi.prototype.rejectFriends = function (userIds) {
        return this.sendPostCmdMsg('rejectFriends', userIds);
    };
    WsApi.prototype.removeFriends = function (userIds) {
        return this.sendPostCmdMsg('removeFriends', userIds);
    };
    WsApi.prototype.getBlacklist = function () {
        return this.sendGetCmdMsg('getBlacklist');
    };
    WsApi.prototype.addToBlackList = function (userIds) {
        return this.sendPostCmdMsg('addToBlackList', userIds);
    };
    WsApi.prototype.removeBlackList = function (userIds) {
        return this.sendPostCmdMsg('removeBlackList', userIds);
    };
    WsApi.prototype.deleteConversation = function (contactId, deleteMessage) {
        if (deleteMessage === void 0) { deleteMessage = false; }
        return this.request('/v1/delete/conversation', {
            contact: contactId,
            delete_message: deleteMessage
        });
    };
    WsApi.prototype.markMessageRead = function (contactId) {
        return this.request('/v1/mark/messages/read', {
            contact: contactId
        });
    };
    WsApi.prototype.listGroups = function () {
        return this.sendGetCmdMsg('listGroups');
    };
    WsApi.prototype.queryGroupInfo = function (roomId) {
        return this.sendGetCmdMsg('queryGroupInfo', { to: roomId });
    };
    WsApi.prototype.queryRoomMember = function (roomId) {
        return this.sendGetCmdMsg('queryRoomMember', { to: roomId });
    };
    WsApi.prototype.getGroupBlackList = function (roomId) {
        return this.sendGetCmdMsg('getGroupBlackList', { to: roomId });
    };
    WsApi.prototype.createGroup = function (groupOption) {
        return this.sendPostCmdMsg('createGroup', null, { ext: groupOption });
    };
    WsApi.prototype.changeGroupInfo = function (groupOption) {
        return this.sendPostCmdMsg('changeGroupInfo', null, { ext: groupOption });
    };
    WsApi.prototype.addGroupMembers = function (roomId, userIds) {
        return this.sendPostCmdMsg('addGroupMembers', [roomId], {
            ext: {
                members: userIds
            }
        });
    };
    WsApi.prototype.addToGroupBlackList = function (roomId, userIds) {
        return this.sendPostCmdMsg('addToGroupBlackList', [roomId], {
            ext: {
                members: userIds
            }
        });
    };
    WsApi.prototype.destroyGroup = function (roomId) {
        return this.sendPostCmdMsg('destroyGroup', [roomId]);
    };
    WsApi.prototype.leaveGroup = function (roomId) {
        return this.sendPostCmdMsg('leaveGroup', [roomId]);
    };
    WsApi.prototype.createRoom = function (groupOption) {
        return this.sendPostCmdMsg('createGroup', null, { ext: groupOption });
    };
    WsApi.prototype.listRooms = function () {
        return this.sendGetCmdMsg('listRooms');
    };
    WsApi.prototype.joinRoom = function (roomId) {
        return this.sendPostCmdMsg('joinRoom', [roomId]);
    };
    WsApi.prototype.quitRoom = function (roomId) {
        return this.sendPostCmdMsg('quitRoom', [roomId]);
    };
    return WsApi;
}(WebSocketClient_1.WebSocketClient));
exports.WsApi = WsApi;
