import { WebSocketClient } from './../WebSocketClient';
import { MsgBase, GroupOption } from '../protocol/MsgBase';
export declare class WsApi extends WebSocketClient {
    token: string;
    from: string;
    sendMsg(msg: Partial<MsgBase>): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    sendGetCmdMsg(action: string, extra?: {}): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    sendPostCmdMsg(action: string, userIds: string[] | null, extra?: {}): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    getRoster(): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    addFriends(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    agreeFriends(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    rejectFriends(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    removeFriends(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    getBlacklist(): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    addToBlackList(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    removeBlackList(userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    deleteConversation(contactId: string, deleteMessage?: boolean): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    markMessageRead(contactId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    listGroups(): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    queryGroupInfo(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    queryRoomMember(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    getGroupBlackList(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    createGroup(groupOption: GroupOption): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    changeGroupInfo(groupOption: GroupOption): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    addGroupMembers(roomId: string, userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    addToGroupBlackList(roomId: string, userIds: string[]): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    destroyGroup(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    leaveGroup(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    createRoom(groupOption: GroupOption): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    listRooms(): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    joinRoom(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
    quitRoom(roomId: string): Promise<import("ts-linker-sdk/dist/types/types").WebSocketResp>;
}
