export declare type MsgType = 'text' | 'media' | 'cmd' | 'attachment';
export declare type RoomType = 'single' | 'room';
export declare type GroupOption = {
    subject: string;
    description: string;
    members: string[];
    optionsPublic: boolean;
    optionsModerate: boolean;
    optionsMembersOnly: boolean;
    optionsAllowInvites: boolean;
};
export declare class MsgBase {
    id: string;
    from: string;
    to: string;
    type: MsgType;
    roomType: RoomType;
    ext: Record<string, string>;
    isValid(): boolean;
    static createMsg(baseMsg: Partial<MsgBase>): MsgBase;
}
