/** 对于消息类型的定义 */
export interface ContactMsg {
  fid: string;
}

export interface ContactAddMsg {
  id: string;
  to: string;
}

export interface ChatroomMsg {
  room_id: string;

  // 管理与编号
  admin_id?: string;

  // 管理与列表
  admins_id?: string[];

  // 成员 ID
  member: string;

  authority?: number;
}

export interface ChatMsg {
  from: string;
  type: 'room';
  to: string;
  msg: {
    type: 'cmd' | 'text' | 'image';
    command?: string;
    action?: string;
    message?: string;
    msg_id?: string;
  };
  msg_id?: string;
  ext?: Record<string, string>;
}
